/********************************************************************
* PIC32MX_J[OLED\eXg 
* vWFNgF PIC32MX_OLED_ImageDisp_UsedSD_TEST
*
* PIC32MXg[jOgAJ[OLED\eXgsB
* ȈՃeXgȂ̂ŁASWŁÃt@CT[`@\͖ɂB
* AASDɎ^ĂABMPt@ĆAJԂ`͉\ɂB
*
* t@CVXeFMMD File System@FAT16iFAT32݊j
* 1.5C`J[OLED: Adafruit_1.5INCH_RGBOLED
*
* Condition:
* 8MHz External X'tal Oscillator, 20x PLL (8MHzx20= 160MHz)
* Fcy=160MHz/2=80MHz, Tcy=12.5ns
*
* CPU: PIC32MX340F256H
*
* fobONF@2018/2/6 N.Ishii
*********************************************************************/
#include <plib.h>		// PIC32 peripheral library
#include "SSD1351_OLEDlibPIC32MX_2.h"
#include <FSIO.h>
#include <SD-SPI.h>

// RtBM[Vݒ
// CPU=80MHz Peri=80MHz,HS+PLL,Divider=1/2,PLL=x20,WDT=Off
#pragma config FNOSC=PRIPLL, POSCMOD=HS, FPLLIDIV=DIV_2
#pragma config FPLLMUL=MUL_20, FPBDIV=DIV_1, FPLLODIV=DIV_1
#pragma config FWDTEN=OFF, ICESEL=ICS_PGx2

/// t@CVXepϐ
FSFILE *fptr;
size_t result;
SearchRec Record;
SearchRec *rptr = &Record;

unsigned short ImageBuffer[10000];	// 16bitBMPf[^obt@F10000[h= 100x100

/// vg^Cv
void DispJacketImage(short Ndot, short Str_X, short Str_Y);
void GoBackSD_SPI_Set(void);	// 180204
void GoBackOLED_SPI_Set(void);	// 180204

int main(void)
{
	short temp;

	/* VXeœKݒ */
	SYSTEMConfigPerformance(80000000);
	mJTAGPortEnable(DEBUG_JTAGPORT_OFF);	// JTAG𖳌 

	/* I/Oݒ */
	AD1PCFG = 0xFFFF;	// fW^

	TRISE = 0x0000;		// LED-RE0 ` RE7
	TRISF = 0x0034;		// VS1011_SDI, VS1011_SDO, VS1011_SCK, VOL_UP_SW, VOL_DWN_SW, LED-RF1, LED-RF0
	TRISC = 0xF000;		// OSC,SOSC
	TRISD = 0x0F00;		// RD7FOLED_RST, RD3iRD4 NGŕύX180125j, OLED_CS, SW2`SW5igpj
	TRISB = 0x40CF;		// RB3FSD_CD, RB4FOLED_DC, RB5FSD_CS,VS1011eM, SKIP_SW, BASS_SW
	TRISG = 0x0280;		// RG6FSCKiSD/OLEDpj,RG7FSD_SDI, RG8FSDOiSD/OLEDpj, MAIN_RTN_SW, EEPROM_SDA.SCL

	/// LEDW[̑SZOgOFF
	LATE = 0;
	LATFbits.LATF0 = 0;
	LATFbits.LATF1 = 0;

	/// XCb`ԕω݋i͖gpj
	mCNOpen(CN_ON, CN3_ENABLE | CN4_ENABLE |  CN11_ENABLE | CN17_ENABLE | CN18_ENABLE, CN5_PULLUP_ENABLE);
		//      SKIP_SW,     BASS_SW,     MAIN_RTN_SW,  VOL_UP_SW,    VOL_DWN_SW,     SD-CD_PULLIP

	temp = PORTB;		// ԍ킹
	temp = PORTF;
	temp = PORTG;

	/// OLED̏
	OLEDInit();		// OLEDRg[[i̖őSʃNAĂBj܂bZ[W͍폜B

	/// J[h}܂ő҂ASDJ[h{
	while(FSInit() != 1){	// Check Mount SD Card and FormatF߂lF'1'=J[htH[}bgρ^'0'=J[h
		// bZ[W\ɂSPIݒ`FWpɂɂȂ̂ƃ^C~O듮삷鎞̂ŊȈՓIɁALED_łɕύXB
		LATFbits.LATF0= !LATFbits.LATF0;	// }҂̍}
		delay_ms(500);
	}

	LATFbits.LATF0= 0;

	//// J[h}ԂłΈȉsB
	/// t@CI[vƃt@C\
	GoBackOLED_SPI_Set();
	OLED_Str(0, 0, "Find Card OK!", CYAN, BLACK);
	delay_ms(1000);
	OLED_Str(0, 0, "             ", BLACK, BLACK);

	/// ŏ̃t@C̃T[` */
	GoBackSD_SPI_Set();
	result = FindFirst("*.BMP", ATTR_ARCHIVE, rptr);

	GoBackOLED_SPI_Set();
	if(result != 0){				// t@C肩H
		OLED_Str(0, 1, "Find No File?", CYAN, BLACK);		// t@CbZ[W
	}
	else{
		/// ŏ́ABMP File Open (Read Mode) 1񂾂AC[vɓOɎsȂƂȂB
		GoBackSD_SPI_Set();
		fptr = FSfopen(Record.filename, "r");
	}

	/// C@[v
	while(1) {
		if(fptr != 0){	// t@CI[vɐ̏ꍇAȉs
			FSfread(ImageBuffer,1,138,fptr);	// wb_񕔂́AKoCgF138oCǵAǂݔ΂
			FSfread(ImageBuffer,2,10000,fptr);	// BMPf[^Aobt@֑Sāi10000[hj]

			GoBackOLED_SPI_Set();
			DispJacketImage(100, 114, 1);		// WPbgC[W`悷

			GoBackSD_SPI_Set();
			FSfclose(fptr);	// C[W`悪IAt@CN[Y

			//// ŉiɁABMPt@C\
			///@SPI2W[𖳌ɂĒP|[gݒɖ߂ĂsB
			GoBackOLED_SPI_Set();
			OLED_Str(2, 15, Record.filename, WHITE, BLACK);

			delay_ms(2000);
			OLED_Clear(BLACK);			// SʃNA

			/// ́ABMPt@CT[`AJԂ
			GoBackSD_SPI_Set();	// OLEDANZXȂ̂ŁASPI2W[L@180202
			result = FindNext(rptr);		// To Next File

			if ((result==0) && (Record.attributes == ATTR_ARCHIVE))	// ́ABMPt@CAI[v
				fptr = FSfopen(Record.filename, "r");
			else {   // ́ABMPt@CȂAŏ̃t@CT[`ČJԂ
				result = FindFirst("*.BMP", ATTR_ARCHIVE, rptr);
				if (result == 0) {
					fptr = FSfopen(Record.filename, "r");	//  File Open (Read Mode)
				}
			}
		}
	}
}

/***********************************************************
* 16bitBMPJ[C[W\֐iAoWPbg\pj
* `TCYOi100x100dotj
* \́AE㌴_(114,1jf`JԂ
*
* ̐
*@@@NdotF\hbgiF100j
*@A@Str_XFhbg`JnXW
*@B@Str_YFhbg`JnYW
************************************************************/
void DispJacketImage(short Ndot, short Str_X, short Str_Y)
{
	short Xpos, Ypos, ptr;

	/// BMPtH[}bg̃f[^́AEɌĔz񂳂Ă̂
	/// ̏ŕ`悷ƁA㉺tl̉摜\ɂȂĂ܂B
	/// ẺfiFptr=9999, Xpos= 114, Ypos= 1)牺Ɍĕ`悷KvB
	ptr= (Ndot * Ndot)-1;
	for(Ypos= Str_Y; Ypos < Str_Y+(Ndot-1); Ypos++){
		for(Xpos=Str_X; Xpos > Str_X-Ndot; Xpos--){
			OLED_Pixel(Xpos, Ypos, ImageBuffer[ptr--]);
		}
	}
}

/***********************************************************
* OLED-SPIANZXɁASD-SPIANZX鎞ɁA
* SD-SPI|[gݒiSPI2W[gpjɖ߂֐
************************************************************/
void GoBackSD_SPI_Set(void)
{
	SPI2CONbits.ON= 1;	// OLEDANZXȂ̂ŁASPI2W[L
}

/*******************************************************************
* SD-SPIANZXɁAOLED-SPIANZX鎞ɁA
* OLED-SPI|[gݒiP|[gɂ\tgEGASPIjɖ߂֐
********************************************************************/
void GoBackOLED_SPI_Set(void)
{
	SPI2CONbits.ON= 0;	// SPI2W[𖳌

	TRISGbits.TRISG6 = 0;	// SCK2sARG6|[go͂ɖ߂B
	TRISGbits.TRISG7 = 1;	// SDI2sARG7|[g͂ɖ߂B
	TRISGbits.TRISG8 = 0;	// SDO2sARG8|[go͂ɖ߂B
}
