/**************************************************************************************************
* Adafruit_1.5INCH_RGBOLED쓮pCu[t@C
* OLEDplFUG2828GDEDF11{L[{[h
* ICFSSD1351
*
* TFAdafruit HP^umgo-tecdqHv
*
* 쐬
* 2018.1.27 N.Ishii
* 1XV
* 2018.2.6 N.Ishii
* SʃNAC疖ɈړBDisplay ON̑ORAMNA̕S~ڗȂȂB
**************************************************************************************************/
#include <plib.h>			// PIC32 peripheral library
#include "SSD1351_OLEDlibPIC32MX_2.h"
#include "ASCII_font.h"			// ANK@8x8hbg
#include "KanjiFont12b.h"			// tHg@12x12hbg
//#include "imagedata.h"		// 
//#include "imagedata_2.h"		// S̉

/****************************************************************************
* Data/Command@w肵āAOLEDɂPoCg𑗐M
*----------------------------------------------------------------------------
*	́F	unsigned char d,char dc
*	óF	
*----------------------------------------------------------------------------
*	lF	dc = 0 : Command, dc = 1 : Data
*****************************************************************************/
void SPI_tx_byte(unsigned char d, char dc)
{
	char Loop;

	if (dc) {
		SPI_DC = 1;
	}
	else {
		SPI_DC = 0;
	}

	SPI_OLED_CS = 0;	// DCm肵ĂACS𗎂Ƃ悤ɏCB180123

	/// CLK𗧉ĂAf[^XVɏCB@180123
	SPI_CLK = 1;

	for (Loop=0;Loop<8;Loop++){
		SPI_CLK = 0;

		SPI_OLED_DATA = 0;
		if ((d & (unsigned char)0x80) != 0){
			SPI_OLED_DATA = 1;
		}

//		Nop();	// ZbgAbvԂ҂́Aɑ}AĂBiXybN=50nSj

		SPI_CLK = 1;	// ̃^C~OŏށB
		d <<= 1;	// ̃f[^Erbg̃xf̂߁A1rbgփVtgēւB

//		Nop();	// z[hԂ҂́Aɑ}AĂBiXybN=50nSj
	}

	SPI_OLED_CS = 1;
}

/****************************************************************************
* OLEDW[IC SSD1351 ݒ
*****************************************************************************/
void OLEDInit(void)
{
	//// OLEDݒ
	delay_ms(2);				// XybN=VDD_IOグA1mSmin҂

	SPI_OLED_CS = 0;			// OLED `bvCl[uxiSPI_SD_CSAʂɑ݁j

	SPI_RES = 1;				// OLED Zbgx

	delay_ms(500);

	/// OLEDZbgEpXo
	SPI_RES = 0;
	delay_ms(500);
	SPI_RES = 1;				// ŊɁAVCC ONĂB

	delay_ms(500);				// 500mSɁAOLEDJn

	/// R}hEf[^Zbg@           ŊɁASEG/COMd́AONĂB
	SPI_tx_byte(0xFD, 0);			// Set Command Lock
	SPI_tx_byte(0x12, 1);			// Unlock OLED driver IC MCU interface from entering command

	SPI_tx_byte(0xFD, 0);			// Set Command Lock
	SPI_tx_byte(0xB1, 1);			// Command A2,B1,B3,BB,BE,C1 accessible if in unlock state

	SPI_tx_byte(0xAE, 0);			// Sleep mode On (Display OFF)

	SPI_tx_byte(0xB3, 0);			// Front Clock Divider
	SPI_tx_byte(0xF1, 0);			// 7:4 = Oscillator Frequency, 3:0 = CLK Div Ratio (A[3:0]+1 = 1..16)

 	SPI_tx_byte(0xCA, 0);			// Set MUX Ratio
	SPI_tx_byte(127, 1);

 	SPI_tx_byte(0xA0, 0);			// Set Re-map
	SPI_tx_byte(0b01110100, 1);		// A[7:6] Set Color Depth= 65k colori16bitJ[j

 	SPI_tx_byte(0x15, 0);			// Set Column
	SPI_tx_byte(0, 1);				// start
	SPI_tx_byte(127, 1);			// end

 	SPI_tx_byte(0x75, 0);			// Set Row
	SPI_tx_byte(0, 1);				// start
	SPI_tx_byte(127, 1);			// end

 	SPI_tx_byte(0xA1, 0);			// Set Display Start Line
	SPI_tx_byte(0, 1);

 	SPI_tx_byte(0xA2, 0);			// Set Display Offset
	SPI_tx_byte(0, 1);

  	SPI_tx_byte(0xB5, 0);			// Set GPIO
 	SPI_tx_byte(0, 1);

  	SPI_tx_byte(0xAB, 0);			// Function Selection
 	SPI_tx_byte(0x01, 1);			// Enable internal Vdd /8-bit paralleliRg[MCŨoX8bitݒj

	/// f[^V[ǵA_uEoCgER}hƂ\́AR}h{f[^ŁA1ZbgƗACiAdafruitR[h͌LHj
  	SPI_tx_byte(0xB1, 0);			// Set Reset(Phase 1) /Pre-charge(Phase 2)
	SPI_tx_byte(0b01110100, 1);		// 9 DCLKs / 7 DCLKs

	/// f[^V[ǵA_uEoCgER}hƂ\́AR}h{f[^ŁA1ZbgƗACiAdafruitR[h͌LHj
  	SPI_tx_byte(0xBE, 0);			// Set VCOMH Voltage
  	SPI_tx_byte(0x05, 1);			// 0.82 x VCC [reset]

  	SPI_tx_byte(0xA6, 0);			// Reset to normal display

  	SPI_tx_byte(0xC1, 0);			// Set Contrast
  	SPI_tx_byte(0xC8, 1);			// Red contrast (reset=0x8A)
  	SPI_tx_byte(0x80, 1);			// Green contrast (reset=0x51)
  	SPI_tx_byte(0xC8, 1);			// Blue contrast (reset=0x8A)

  	SPI_tx_byte(0xC7, 0);			// Master Contrast Current Control
  	SPI_tx_byte(0x0F, 1);			// 0-15

  	SPI_tx_byte(0xB4, 0);			// Set Segment Low Voltage(VSL)
  	SPI_tx_byte(0xA0, 1);
  	SPI_tx_byte(0xB5, 1);
  	SPI_tx_byte(0x55, 1);

  	SPI_tx_byte(0xB6, 0);			// Set Second Precharge Period
  	SPI_tx_byte(0x01, 1);			// 1 DCLKS

  	SPI_tx_byte(0x9E, 0);			// Scroll Stop Moving

	OLED_Clear(BLACK);			// SʃNACړBDisplay ON̑ORAMNA̕S~ڗȂȂB

	SPI_tx_byte(0xAF, 0);			// Sleep mode On (Display ON)
}

/***************************
* ʏ֐
* pFw肠
****************************/
void OLED_Clear(unsigned short color){
	short i;

	/// `GAݒ
  	SPI_tx_byte(0x15, 0);		// Set Column
  	SPI_tx_byte(0x00, 1);		// start
  	SPI_tx_byte(ENDCOL-1, 1);	// end

  	SPI_tx_byte(0x75, 0);		// Set Row
  	SPI_tx_byte(0x00, 1);		// start
  	SPI_tx_byte(ENDROW-1, 1);	// end

	/// SGAwFŖ߂B
  	SPI_tx_byte(0x5C, 0);		// Write RAM

	// 16bit color mode
	for(i=0; i<(ENDCOL)*(ENDROW); i++){
		SPI_tx_byte((unsigned char)(color >> 8), 1);
		SPI_tx_byte((unsigned char)color, 1);
	}
}

/***********************************
*  PsNZ\֐
*  W(0,0)-(127,127) 
***********************************/
void OLED_Pixel(short Xpos, short Ypos, unsigned short color){
	/* if raw>128 or colum >128 then do nothing  */

	if((Xpos<=ENDCOL-1) && (Ypos<=ENDROW-1)){
	  	SPI_tx_byte(0x15, 0);		// Set Column
	  	SPI_tx_byte(Xpos, 1);		// start
	  	SPI_tx_byte(Xpos, 1);		// end

 	 	SPI_tx_byte(0x75, 0);		// Set Row
	  	SPI_tx_byte(Ypos, 1);		// start
	  	SPI_tx_byte(Ypos, 1);		// end

 	 	SPI_tx_byte(0x5C, 0);		// Write RAM
		SPI_tx_byte((unsigned char)(color >> 8), 1);
		SPI_tx_byte((unsigned char)color, 1);
	}
}

/***************************
*  `֐
***************************/
#define	abs(a)	(((a)>0) ? (a) : -(a))
void OLED_Line(short x0, short y0, short x1, short y1, unsigned short color)
{
	short steep, t;
	short deltax, deltay, error;
	short x, y;
	short ystep;

	y0=ENDROW-y0 -1;	// @YW]i_j
	y1=ENDROW-y1 -1;

	/// ̑傫ق߂
	steep = (abs(y1 - y0) > abs(x1 - x0));

	/// A̓ւ
	if(steep){
		t = x0; x0 = y0; y0 = t;
		t = x1; x1 = y1; y1 = t;
	}
	if(x0 > x1) {
		t = x0; x0 = x1; x1 = t;
		t = y0; y0 = y1; y1 = t;
	}

	deltax = x1 - x0;	// XvZ
	deltay = abs(y1 - y0);

	error = 0;
	y = y0;
	/// XŃXebv̐؂ւ
	if(y0 < y1) ystep = 1; else ystep = -1;

	/// _ŕ`
	for(x=x0; x<=x1; x++) {
		if(steep) OLED_Pixel(y,x,color); else OLED_Pixel(x,y,color);
		error += deltay;
		if((error << 1) >= deltax) {
			y += ystep;
			error -= deltax;
		}
	}
}

/*************************************
*  ~`֐
*  S_Ɣaw
*  (FussỹASYgp)
**************************************/
void OLED_Circle(int x0, int y0, int r, unsigned short color){
	int x = r;
	int y = 0;
	int F = -2 * r + 3;

	while(x >= y){
		OLED_Pixel(x0+x, y0+y, color);
		OLED_Pixel(x0-x, y0+y, color);
		OLED_Pixel(x0+x, y0-y, color);
		OLED_Pixel(x0-x, y0-y, color);
		OLED_Pixel(x0+y, y0+x, color);
		OLED_Pixel(x0-y, y0+x, color);
		OLED_Pixel(x0+y, y0-x, color);
		OLED_Pixel(x0-y, y0-x, color);
		if(F >= 0){
			x--;
			F -= 4 * x;
		}
		y++;
		F += 4 * y + 2;
	}
}

/*
///// ͖gp
//////////////////////////////////////////////////////////
// 16bitBMPJ[C[W\֐
// 128x128dotΉ
/////////////////////////////////////////////////////////
void OLED_Image(void){
	short Xpos, Ypos;
	short ptr;	// PIC32MX̏ꍇAint= 32bit^short= 16bit

	/// BMPtH[}bg̃f[^́AEɌĔz񂳂Ă̂
	/// ̏ŕ`悷ƁA㉺tl̉摜\ɂȂĂ܂B
	/// Ẻfiptr=(32906/2)-1)=16452, Xpos= 127, Ypos= 0)牺Ɍĕ`悷KvB
	ptr= 16452;
	for(Ypos=0; Ypos < ENDROW; Ypos++){
		for(Xpos=ENDCOL-1; Xpos > -1; Xpos--){
			OLED_Pixel(Xpos, Ypos, ImageData[ptr--]);
		}
	}
}
*/

/*****************************************
*  ANK\֐ 8x8hbg
*  128/8=16/s@128/8=16s
*  (0, 0) - (15, 15)͈̔
******************************************/
void OLED_Char(char colum, char line,  unsigned char letter, unsigned short color1, unsigned short color2){
	unsigned char j, i, Mask;

	if((colum < 16) && (line < 16)){		// ͈̓`FbN
		for(j=0; j<5; j++){				// 5hbg
			Mask = 0x80;				// ʃrbg\
			for(i=0; i<8; i++){			// c1C\
				if((chrom[letter-0x20][j] & Mask) != 0)
					OLED_Pixel(colum*8+j+3, (line+1)*8-i, color1);
				else
					OLED_Pixel( colum*8+j+3, (line+1)*8-i, color2); //wiF
				Mask = Mask >> 1;
			}
		}

		/// tHǵA5botAćA3dot*8dotXy[XwiFœhԂB
		for(j=5; j<8; j++){
			for(i=0; i<8; i++){
				OLED_Pixel(colum*8+j+3, (line+1)*8-i, color2); //wiF
			}
		}
	}
}

/*******************************************
*   `֐
*   8x8dot Font̏ꍇF1616sŎw
********************************************/
void OLED_Str(char colum, char line, char *s, unsigned short color1, unsigned short color2){
   	while (*s){
		OLED_Char(colum++, line, *s++, color1, color2);
		if(colum >= XChar){
			line++;
			colum = 0;
			if(line >= YLine)
				line = 0;
		}
	}
}

/**************************************************
* \֐
* @tHg12x12
*   R[h͈̔͂`FbNُȂ-1Ԃ
*@ ߂lF0= tHg@1= ptHg
***************************************************/
short OLED_Kanji(char line, char colum, unsigned char *ptr, unsigned short color1, unsigned short color2)
{
	short low, high;

	high = *ptr++;
	low = *ptr;
	// ͈̓`FbNƕ\
	if(((high > 0x80) && (high < 0xA0)) || ((high > 0xDF) && (high < 0xEB))) {
		if((low > 0x3F) && (low < 0xFD) && (low != 0x7F)) {
			KanjiCode(line, colum, high, low, color1, color2);		// \
			return(0);							// ߂
		}
		else
			return(-1);							// G[߂
	}
	else
		return(-1);

}

/*************************************
* \@R[hwŕ\
* @2oCgR[hŎw
*   \ʒu9/9sŎw
**************************************/
void KanjiCode(char line, char colum, short upcode, short lowcode, unsigned short color1, unsigned short color2)
{
	short upper, lower, i, j, pos;
	unsigned char Mask;
	  
	if((line < 9) && (colum < 9)){					// ʓH line 109C@180127
		// R[hzCfbNXvZ
		upper = (upcode -0x81)*188;					// xxFC-xx40+1-1(7F)
		if(lowcode < 0x7F)							// R[h7F̓XLbv
			lower = (lowcode - 0x40);
		else
			lower = (lowcode - 0x41);					// 7FR[h1
		// \ó@3oCg2C6JԂ
		for(j=0; j<6; j++){
			// 8hbgA̕\
			Mask = 0x80;
			for(i=0; i<8; i++){
				// PCڑO8hbg\
				if((KanjiFont12b[upper+lower][j*3] & Mask) != 0)
					OLED_Pixel(colum*13+i+3, line*13+j*2, color1);
				else
					OLED_Pixel(colum*13+i+3, line*13+j*2, color2); 	//wiF
				// 2Cڌ㔼8hbg\
				if((KanjiFont12b[upper+lower][j*3+2] & Mask) != 0)
					OLED_Pixel(colum*13+i+7, line*13+j*2+1, color1);
				else
					OLED_Pixel(colum*13+i+7, line*13+j*2+1, color2); 	//wiF
				Mask = Mask >> 1;
			}
			// 4hbg\
			Mask = 0x80;
			// 1Cڌ㔼4hbg\
			for(i=0; i<4; i++){
				if((KanjiFont12b[upper+lower][j*3+1] & Mask) != 0)
					OLED_Pixel(colum*13+i+11, line*13+j*2, color1);
				else
					OLED_Pixel(colum*13+i+11, line*13+j*2, color2);	 //wiF
				Mask = Mask >> 1;
			}
			// 2CڑO4hbg\
			for(i=4; i<8; i++){
				if((KanjiFont12b[upper+lower][j*3+1] & Mask) != 0)
					OLED_Pixel(colum*13+i-1, line*13+j*2+1, color1);
				else
					OLED_Pixel(colum*13+i-1, line*13+j*2+1, color2); 	//wiF
				Mask = Mask >> 1;
			}
		}
	}
}

/*********************************************************
* \
*  9~9sŎw
*********************************************************/
void Kanji_Str(char line, char colum, const short* ptr, unsigned short color1, unsigned short color2)
{
	while(*ptr){
		if((line < 9) && (colum < 9)){				// ʓH
			KanjiCode(line, colum++, (short)*ptr++, (short)*ptr++, color1, color2);
			if(colum > 8){
				line++;
				colum = 0;
				if(line > 8)
					line = 0;
			}
		}
	}
}

/**********************************
*  [vx֐@msecP
**********************************/
void delay_us(unsigned short usec)
{
	unsigned short i, Max;
	
	Max = usec * Fosc/10;
	for(i=0; i<Max; i++)
	{	}
}

/**********************************
*  [vx֐@msecP
**********************************/
void delay_ms(unsigned short msec)
{
        unsigned short i;

        for(i=0; i<msec; i++)
                delay_us(1000);
}

